// Program demo pentru Laboratorul de Metode Numerice
// Lucrarea 4 
// Referinta
// G.Ciuprina, M.Rebican, D.Ioan - Indrumar de metode numerice, Editura Printech
// 2013, detalii la mn.lmn.pub.ro
// last update 27 oct 2013, by G.C., scilab 5.4.1
clear;
funcprot(0);
exec('functii/jacobi.sci');
exec('functii/intro_date.sci');
exec('functii/matrice.sci');
exec('functii/gauss_seidel.sci');
exec('functii/gen_sist.sci');
exec('functii/alte_functii.sci');
exec('functii/x_message.sci');

format('v',10);
optiune = x_choose(['Rezolvare sisteme cu Jacobi/Gauss-Seidel';'Analiza algoritmilor'],['L04 - Metode iterative de rezolvare a';'sistemelor algebrice liniare']);

select optiune
case 0 then
    //chdir ../;
    //exec('main.sci');
case 1 then
    // rezolvare sisteme
    disp('===================> Rezolvare cu metoda Jacobi');
    [a, b, n, eps,NMAX] = intro_date1();
    [rho,norma] = testConv(a,1);
    if (rho>=1) then
        printf('\n\nMetoda Jacobi nu este convergenta pentru sistemul dat!\n');
        printf('Raza de convergenta a matricei de iteratie: rho(M) = %5.3f\n',rho);
        printf('Norma matricei de iteratie: || M || = %5.3f\n',norma);
    else
        nrit = NMAX;
        [x,err,cit] = Jacobi(n,a,b,nrit,eps);
        printf('\nMetoda Jacobi este convergenta pentru sistemul dat.');
        printf('\nRaza de convergenta a matricei de iteratie: rho(M) = %5.3f',rho);
        printf('\nNorma matricei de iteratie: || M || = %5.3f',norma);
        printf('\nEroarea impusa: %14.10f',eps);
        printf('\nEroarea atinsa: %14.10f dupa %i iteratii',err(cit),cit);
        printf('\nSolutia sistemului:\n');
        for i=1:length(x),
            printf('|%14.10f|\n',x(i));
        end;
    end;
    // metoda Gauss-Seidel
    disp('===================> Rezolvare cu metoda Gauss-Seidel');
    [rho,norma] = testConv(a,2);
    if (rho>=1) then
        printf('\n\nMetoda Gauss-Seidel nu este convergenta pentru sistemul dat!\n');
        printf('Raza de convergenta a matricei de iteratie: rho(M) = %5.3f\n',rho);
        printf('Norma matricei de iteratie: || M || = %5.3f\n',norma);
    else
        nrit = 10000;
        [x,err,cit] = Gauss_Seidel(n,a,b,nrit,eps);
        printf('\nMetoda Gauss-Seidel este convergenta pentru sistemul dat.');
        printf('\nRaza de convergenta a matricei de iteratie: rho(M) = %5.3f',rho);
        printf('\nNorma matricei de iteratie: || M || = %5.3f',norma);
        printf('\nEroarea impusa: %14.10f',eps);
        printf('\nEroarea atinsa: %14.10f dupa %i iteratii',err(cit),cit);
        printf('\nSolutia sistemului:\n');
        for i=1:length(x),
            printf('|%14.10f|\n',x(i));
        end;
    end;
    exec('mainL04.sci');
case 2 then
    // Analiza algoritmilor

    optan = x_choose(['Eroare vs. iteratii';'Nr.iteratii necesare vs. norma matricei'],['L04 - Metode iterative de rezolvare a';'sistemelor algebrice liniarei - analiza algoritmilor']);

    select optan
    case 0 then
        exec('mainL04.sci');
    case 1 then
        [norma, nini,npas,nfin] = intro_date3();
        index = 1;
        iter = [];
        eroare = [];
        eps = -1; // se opreste de fapt dupa nr max iteratii
        NMAX = 17;
        disp('=====================================================');
        disp('Metoda Jacobi - eroare in functie de iteratie, ');
        disp('                      pentru norma constanta');
        for n = nini:npas:nfin
            printf("\n dimensiunea sistemului este %d",n);
            [a,x,b] = gen_sist(n,norma);
            [xJ,errJ,citJ] = Jacobi(n,a,b,NMAX,eps);
            //xtitle('Metoda Jacobi','iteratia','eroarea');
            printf("\n dimensiunea sistemului n = %d",n);
            for ii = 1:4:citJ
                printf("\n iteratia = %d, norma Cebasev a corectiei = %e',ii,errJ(ii));
            end
            it = 1:citJ;
            eroare = [eroare errJ];
            iter = [iter it'];
            mystring = strcat(['Jacobi , norma = ',string(norma),...
            '   n = ',string(n)]);
            if index == 1
                tit = mystring;

            else 
                tit =  tit + '@' + mystring;
            end
            style(index) = index + 1;
            index = index + 1;
        end	
        [rho,normaGS] = testConv(a,2);
        disp('=====================================================');
        disp('Metoda Gauss-Seidel - eroare in functie de iteratie,');
        disp('                             pentru norma constanta');
        for n = nini:npas:nfin
            printf("\n dimensiunea sistemului este %d",n);
            [a,x,b] = gen_sist(n,norma);
            [xGS,errGS,citGS] = Gauss_Seidel(n,a,b,NMAX,eps);
            //xtitle('Metoda Jacobi','iteratia','eroarea');
            for ii = 1:4:citGS
                printf("\n iteratia = %d, norma euclidiana a corectiei = %e',ii,errGS(ii));
            end
            it = 1:citGS;
            eroare = [eroare errGS];
            iter = [iter it'];
            mystring = strcat(['Gauss-Seidel , norma = ',string(normaGS),...
            '   n = ',string(n)]);
            tit =  tit + '@' + mystring;
            style(index) = index + 1;
            index = index + 1;
        end	

        //xclear();
        //delmenu(0,'File');
        //delmenu(0,'3D Rot.');
        //actions = ['xdel(0);'];
        //addmenu(0,'Exit');
        //Exit_0 = [actions(1)];
        //xsetech([0,0,1,0.9]);
        //plot2d('nl',iter,eroare,style,"181",leg=tit);
        //xgrid();
        //wait2close(); 
        x_message('Eroare in functie de numar de iteratii, pentru Jacobi si Gauss-Seidel - de inclus in referat.','');
        //	exec('mainL04.sci');
    case 2 then
        [eps, n] = intro_date4();
        iteratii = [];
        NMAX = 1e100;  // se opreste dupa norma
        disp('=====================================================');
        disp('Jacobi si Gauss Seidel - nr iteratii in functie de norma matricei, ');
        disp('                      pentru eroare constanta');
        printf("\n dimensiunea sistemului este %d",n);
        itnJ = [];
        itnGS = [];
        for norma = 0.1:0.1:0.9
            [a,x,b] = gen_sist(n,norma);
            [xJ,errJ,citJ] = Jacobi(n,a,b,NMAX,eps);
            [xGS,errGS,citGS] = Gauss_Seidel(n,a,b,NMAX,eps);
            printf("\n norma = %f, nr iter. J = %d, nr iter. GS = %d',norma,citJ,citGS);
            itnJ = [itnJ; citJ];
            itnGS = [itnGS; citGS];
        end
        iteratii = [iteratii itnJ itnGS];
        tit = strcat(['Jacobi , eroare = ',string(eps),...
        '   n = ',string(n)]);
        mystring = strcat(['Gauss-Seidel , eroare = ',string(eps),...
        '   n = ',string(n)]);
        tit =  tit + '@' + mystring;
        style(1) = 2;
        style(2) = 5;
        //xclear();
        //delmenu(0,'File');
        //delmenu(0,'3D Rot.');
        //actions = ['xdel(0);'];
        //addmenu(0,'Exit');
        //Exit_0 = [actions(1)];
        //xsetech([0,0,1,0.9]);
        //plot2d('nn',0.1:0.1:0.9,iteratii,style,"181",leg=tit);
        //xgrid();
        //wait2close(); 
        x_message('Numar de iteratii in functie de norma matricei de iteratie, pentru Jacobi si Gauss-Seidel - de inclus in referat.','');
        //	exec('mainL04.sci');
    end
    exec('mainL04.sci');
end;

